/*
rndnum.c - random number generator
    generates random number with normal distribution
    from 0 to 2^32 - 1
Version 0.1.0
Copyright (C) 2003  dondalah@ripco.com (Dondalah)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License as
published by the Free Software Foundation; either version 2 of
the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to:

    Free Software Foundation, Inc.
    59 Temple Place - Suite 330
    Boston, MA  02111-1307, USA.
*/

/*
Usage:
        unsigned int i;
        i = rndnum(unsigned int lim, unsigned char *rndSeed);
        where lim is 1 to 2^32 - 1
*/

/*
Subroutine calls:
        unsigned int i;
        i = rndpwr(int bits, unsigned char *rndSeed);
*/

#define MODBITS 32

unsigned int rndpwr(int bits,unsigned char *rndSeed);

unsigned int rndnum(unsigned int lim,unsigned char *rndSeed)
    {
    unsigned int rslt;
    _asm push ebx
    _asm push edx
    _asm mov  edx,12[ebp]
    _asm push edx
    _asm mov  edx,32
    _asm push edx
    _asm call rndpwr
    _asm add  esp,8 ; pop 2 parms
    _asm mov  ebx,8[ebp]
    _asm mul  ebx
    _asm mov  [rslt],edx
    _asm pop  edx
    _asm pop  ebx
    return(rslt);
    } /* rndnum */
